/***************************************************************************
 *            zipitgfx.h
 *
 *  Wed Mar  8 00:56:22 2006
 *  Copyright  2006  Albert Santoni
 *  gamegod [at] sympatico |dot| ca
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _ZIPITGFX_H
#define _ZIPITGFX_H

#ifdef __cplusplus
extern "C"
{
#endif

#include <linux/fb.h>
#include <stdio.h>

struct ScreenData
{
	struct fb_var_screeninfo vinfo;
    struct fb_fix_screeninfo finfo;
	long int iScreenSize;					//Number of ??? in the screen... (bytes?)
	int fbfd;
	unsigned char *fbp;
	unsigned char* iBackBuffer;
};	
	
struct ImageData
{
	int rows; 
	int cols; 
	unsigned char* pixelData;
};

int drawChar(struct ScreenData* screen, char ch, int x, int y, char color);
int drawText(struct ScreenData* screen, char* text, int x, int y, char color);
int drawTextCutoff(struct ScreenData* screen, char* text, int x, int y, char color, int length);
int initScreen(struct ScreenData* screen);
int shutdownScreen(struct ScreenData* screen);
int render(struct ScreenData* screen);
int writePixel(struct ScreenData* screen, int x, int y, char val);
int clearBackBuffer(struct ScreenData* screen);
void drawLine(struct ScreenData* screen, int x0, int y0, int x1, int y1, char color);
void fillRect(struct ScreenData* screen, int x0, int y0, int x1, int y1, char color);
int drawBitmap(struct ScreenData* screen, struct ImageData* bitmap, int startX, int startY);
long getImageInfo(FILE* inputFile, long offset, int numberOfChars);
struct ImageData* loadBitmap(char* strFilename);
	
	
	

#ifdef __cplusplus
}
#endif

#endif /* _ZIPITGFX_H */
